## libquotient 0.6.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
if (POLICY CMP0092)
cmake_policy(SET CMP0092 NEW)
endif()

set(API_VERSION "0.6")
project(Quotient VERSION "${API_VERSION}.6" LANGUAGES CXX)

option(${PROJECT_NAME}_INSTALL_TESTS "install quotest (former qmc-example) application" ON)
# https://github.com/quotient-im/libQuotient/issues/369
option(${PROJECT_NAME}_ENABLE_E2EE "end-to-end encryption (E2EE) support" OFF)

include(CheckCXXCompilerFlag)
if (WIN32)
    if (NOT CMAKE_INSTALL_LIBDIR)
        set(CMAKE_INSTALL_LIBDIR ".")
    endif ()

    if (NOT CMAKE_INSTALL_BINDIR)
        set(CMAKE_INSTALL_BINDIR ".")
    endif ()

    if (NOT CMAKE_INSTALL_INCLUDEDIR)
        set(CMAKE_INSTALL_INCLUDEDIR "include")
    endif ()
else()
    include(GNUInstallDirs)
    set(INCLUDEDIR_INIT ${PROJECT_NAME})
endif(WIN32)
set(${PROJECT_NAME}_INSTALL_INCLUDEDIR
        "${CMAKE_INSTALL_INCLUDEDIR}/${INCLUDEDIR_INIT}" CACHE PATH
        "directory to install ${PROJECT_NAME} include files to")

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build" FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

if (MSVC)
    add_compile_options(/EHsc /W4
        /wd4100 /wd4127 /wd4242 /wd4244 /wd4245 /wd4267 /wd4365 /wd4456 /wd4459
        /wd4464 /wd4505 /wd4514 /wd4571 /wd4619 /wd4623 /wd4625 /wd4626 /wd4706
        /wd4710 /wd4774 /wd4820 /wd4946 /wd5026 /wd5027)
else()
    foreach (FLAG all "" pedantic extra error=return-type no-unused-parameter
                  no-gnu-zero-variadic-macro-arguments)
        CHECK_CXX_COMPILER_FLAG("-W${FLAG}" WARN_${FLAG}_SUPPORTED)
        if ( WARN_${FLAG}_SUPPORTED AND NOT CMAKE_CXX_FLAGS MATCHES "(^| )-W?${FLAG}($| )")
            add_compile_options(-W${FLAG})
        endif ()
    endforeach ()
endif()

find_package(Qt5 5.9 REQUIRED Network Gui Multimedia Test)
get_filename_component(Qt5_Prefix "${Qt5_DIR}/../../../.." ABSOLUTE)

if (${PROJECT_NAME}_ENABLE_E2EE)
    if ((NOT DEFINED USE_INTREE_LIBQOLM OR USE_INTREE_LIBQOLM)
            AND EXISTS ${PROJECT_SOURCE_DIR}/3rdparty/libQtOlm/lib/utils.h)
        add_subdirectory(3rdparty/libQtOlm)
        include_directories(3rdparty/libQtOlm)
        if (NOT DEFINED USE_INTREE_LIBQOLM)
            set (USE_INTREE_LIBQOLM 1)
        endif ()
    endif ()
    if (NOT USE_INTREE_LIBQOLM)
        set(SAVED_CMAKE_INSTALL_INCLUDEDIR ${CMAKE_INSTALL_INCLUDEDIR})
        set(CMAKE_INSTALL_INCLUDEDIR ${CMAKE_INSTALL_INCLUDEDIR})
        find_package(QtOlm 3.0.1 REQUIRED)
        if (NOT QtOlm_FOUND)
            message( WARNING "libQtOlm not found; configuration will most likely fail.")
            message( WARNING "Make sure you have installed libQtOlm development files")
            message( WARNING "as a package or checked out the library sources in lib/.")
            message( WARNING "See also BUILDING.md")
        endif ()
    endif ()
else ()
    message( STATUS "End-to-end encryption (E2EE) support is turned off.")
endif ()

if (GTAD_PATH)
    get_filename_component(ABS_GTAD_PATH "${GTAD_PATH}" REALPATH)
endif ()
if (MATRIX_DOC_PATH)
    get_filename_component(ABS_API_DEF_PATH "${MATRIX_DOC_PATH}/api" REALPATH)
endif ()
if (ABS_GTAD_PATH AND ABS_API_DEF_PATH)
    if (NOT CLANG_FORMAT)
        set(CLANG_FORMAT clang-format)
    endif()
    get_filename_component(ABS_CLANG_FORMAT "${CLANG_FORMAT}" PROGRAM)
endif()

message( STATUS )
message( STATUS "=============================================================================" )
message( STATUS "                       ${PROJECT_NAME} Build Information" )
message( STATUS "=============================================================================" )
message( STATUS "Version: ${PROJECT_VERSION}, API version: ${API_VERSION}")
if (CMAKE_BUILD_TYPE)
    message( STATUS "Build type: ${CMAKE_BUILD_TYPE}")
endif(CMAKE_BUILD_TYPE)
message( STATUS "Using compiler: ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}" )
message( STATUS "Install Prefix: ${CMAKE_INSTALL_PREFIX}" )
message( STATUS "  Header files will be installed to ${CMAKE_INSTALL_PREFIX}/${${PROJECT_NAME}_INSTALL_INCLUDEDIR}" )
message( STATUS "Using Qt ${Qt5_VERSION} at ${Qt5_Prefix}" )
if (ABS_API_DEF_PATH AND ABS_GTAD_PATH)
    message( STATUS "Generating API stubs enabled (use --target update-api)" )
    message( STATUS "  Using GTAD at ${ABS_GTAD_PATH}" )
    message( STATUS "  Using API files at ${ABS_API_DEF_PATH}" )
    if (ABS_CLANG_FORMAT)
        message( STATUS "clang-format is at ${ABS_CLANG_FORMAT}")
    else ()
        message( STATUS "${CLANG_FORMAT} is NOT FOUND; API files won't be reformatted")
    endif ()
endif ()
find_package(Git)
if (${PROJECT_NAME}_ENABLE_E2EE)
    if (USE_INTREE_LIBQOLM)
        message( STATUS "Using in-tree libQtOlm")
        if (GIT_FOUND)
            execute_process(COMMAND
                "${GIT_EXECUTABLE}" rev-parse -q HEAD
                WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/3rdparty/libQtOlm
                OUTPUT_VARIABLE QTOLM_GIT_SHA1
                OUTPUT_STRIP_TRAILING_WHITESPACE)
            message( STATUS "  Library git SHA1: ${QTOLM_GIT_SHA1}")
        endif (GIT_FOUND)
    else ()
        message( STATUS "Using libQtOlm ${QtOlm_VERSION} at ${QtOlm_DIR}")
    endif ()
endif ()
message( STATUS "=============================================================================" )
message( STATUS )

# Set up source files
set(lib_SRCS
    lib/networkaccessmanager.cpp
    lib/connectiondata.cpp
    lib/connection.cpp
    lib/ssosession.cpp
    lib/logging.cpp
    lib/room.cpp
    lib/user.cpp
    lib/avatar.cpp
    lib/uri.cpp
    lib/uriresolver.cpp
    lib/syncdata.cpp
    lib/settings.cpp
    lib/networksettings.cpp
    lib/converters.cpp
    lib/util.cpp
    lib/encryptionmanager.cpp
    lib/eventitem.cpp
    lib/events/event.cpp
    lib/events/roomevent.cpp
    lib/events/stateevent.cpp
    lib/events/eventcontent.cpp
    lib/events/roomcreateevent.cpp
    lib/events/roomtombstoneevent.cpp
    lib/events/roommessageevent.cpp
    lib/events/roommemberevent.cpp
    lib/events/roompowerlevelsevent.cpp
    lib/events/typingevent.cpp
    lib/events/receiptevent.cpp
    lib/events/reactionevent.cpp
    lib/events/callanswerevent.cpp
    lib/events/callcandidatesevent.cpp
    lib/events/callhangupevent.cpp
    lib/events/callinviteevent.cpp
    lib/events/directchatevent.cpp
    lib/events/encryptionevent.cpp
    lib/events/encryptedevent.cpp
    lib/events/roomkeyevent.cpp
    lib/jobs/requestdata.cpp
    lib/jobs/basejob.cpp
    lib/jobs/syncjob.cpp
    lib/jobs/mediathumbnailjob.cpp
    lib/jobs/downloadfilejob.cpp
)

set(CSAPI_DIR csapi)
set(FULL_CSAPI_DIR lib/${CSAPI_DIR})
set(ASAPI_DEF_DIR application-service/definitions)
set(ISAPI_DEF_DIR identity/definitions)

if (MATRIX_DOC_PATH AND GTAD_PATH)
    if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.12.0")
        # We use globbing with CONFIGURE_DEPENDS to produce two file lists:
        # one of all API files for clang-format and another of just .cpp
        # files to supply for library source files. Since we expect these
        # file lists to only change due to GTAD invocation, we only use
        # CONFIGURE_DEPENDS when pre-requisites to update API are met.
        # Read comments next to each file(GLOB_RECURSE) for caveats.
        set(add_CONFIGURE_DEPENDS "CONFIGURE_DEPENDS")
    endif()
    set(FULL_CSAPI_SRC_DIR ${ABS_API_DEF_PATH}/client-server)
    file(GLOB_RECURSE API_DEFS RELATIVE ${PROJECT_SOURCE_DIR}
        ${FULL_CSAPI_SRC_DIR}/*.yaml
        ${ABS_API_DEF_PATH}/${ASAPI_DEF_DIR}/*.yaml
        ${ABS_API_DEF_PATH}/${ISAPI_DEF_DIR}/*.yaml
    )
    add_custom_target(generate-unformatted-api
        ${ABS_GTAD_PATH} --config ../gtad/gtad.yaml --out ${CSAPI_DIR}
            ${FULL_CSAPI_SRC_DIR}
            old_sync.yaml- room_initial_sync.yaml- # deprecated
            search.yaml- # current GTAD is limited in handling move-only data
            key_backup.yaml- # immature and buggy in terms of API definition
            sync.yaml- # we have a better handcrafted implementation
        WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/lib
        SOURCES gtad/gtad.yaml
                gtad/data.h.mustache
                gtad/operation.h.mustache
                gtad/operation.cpp.mustache
                ${API_DEFS}
        VERBATIM
    )
    add_custom_target(update-api DEPENDS generate-unformatted-api)
    if (ABS_CLANG_FORMAT)
        set(CLANG_FORMAT_ARGS -i -sort-includes ${CLANG_FORMAT_ARGS})
        # FIXME: the list of files should be produced after GTAD has run.
        # For now it's produced at CMake invocation. If file() hasn't found
        # any files at that moment, clang-format will be called with an empty
        # list of files and choke. Taking outfiles.txt from GTAD could be
        # an option but this, too, must be done during the build stage, and
        # there's no crossplatform way to use the contents of a file as
        # input for a build target command.
        file(GLOB_RECURSE api_ALL_SRCS ${add_CONFIGURE_DEPENDS}
             ${FULL_CSAPI_DIR}/*.*
             lib/${ASAPI_DEF_DIR}/*.*
             lib/${ISAPI_DEF_DIR}/*.*)
        if (api_ALL_SRCS)
            add_custom_target(format-api
                ${ABS_CLANG_FORMAT} ${CLANG_FORMAT_ARGS} ${api_ALL_SRCS}
                DEPENDS generate-unformatted-api
                VERBATIM)
            add_dependencies(update-api format-api)
        endif()
    endif()
endif()

# Make no mistake: CMake cannot run gtad first and then populate the list of
# resulting api_SRCS files. In other words, placing the below statement after
# the block above will not lead to CMake magically reconfiguring the build
# after building the update-api target. CONFIGURE_DEPENDS somewhat helps,
# at least forcing the build system to reevaluate the glob before building
# the next target. Otherwise, you have to watch out if gtad has created
# new files and if it has, re-run cmake.
file(GLOB_RECURSE api_SRCS ${add_CONFIGURE_DEPENDS} ${FULL_CSAPI_DIR}/*.cpp)

set(tests_SRCS tests/quotest.cpp)

add_library(${PROJECT_NAME} ${lib_SRCS} ${api_SRCS})
if (${PROJECT_NAME}_ENABLE_E2EE)
    target_compile_definitions(${PROJECT_NAME} PUBLIC ${PROJECT_NAME}_E2EE_ENABLED)
endif()
set_target_properties(${PROJECT_NAME} PROPERTIES
    VERSION "${PROJECT_VERSION}"
    SOVERSION ${API_VERSION}
    INTERFACE_${PROJECT_NAME}_MAJOR_VERSION ${API_VERSION}
)
set_property(TARGET ${PROJECT_NAME} APPEND PROPERTY
             COMPATIBLE_INTERFACE_STRING ${PROJECT_NAME}_MAJOR_VERSION)

target_compile_features(${PROJECT_NAME} PUBLIC cxx_std_17)

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/lib>
    $<INSTALL_INTERFACE:${${PROJECT_NAME}_INSTALL_INCLUDEDIR}>
)
if (${PROJECT_NAME}_ENABLE_E2EE)
    target_link_libraries(${PROJECT_NAME} QtOlm)
    set(FIND_DEPS "find_dependency(QtOlm)") # For QuotientConfig.cmake.in
endif()
target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Network Qt5::Gui Qt5::Multimedia)

set(TEST_BINARY quotest)
add_executable(${TEST_BINARY} ${tests_SRCS})
target_link_libraries(${TEST_BINARY} Qt5::Core Qt5::Test ${PROJECT_NAME})

configure_file(${PROJECT_NAME}.pc.in ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc @ONLY NEWLINE_STYLE UNIX)

# Installation

install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}Targets
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        INCLUDES DESTINATION ${${PROJECT_NAME}_INSTALL_INCLUDEDIR}
)
install(DIRECTORY lib/ DESTINATION ${${PROJECT_NAME}_INSTALL_INCLUDEDIR}
        FILES_MATCHING PATTERN "*.h")

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

# This CMakeLists file assumes that the library is installed to CMAKE_INSTALL_PREFIX
# and ignores the in-tree library code. You can use this to start work on your own client.

project(quotest CXX)

include(CheckCXXCompilerFlag)
if (NOT WIN32)
    include(GNUInstallDirs)
endif(NOT WIN32)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build" FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

if (NOT CMAKE_INSTALL_LIBDIR)
    set(CMAKE_INSTALL_LIBDIR ".")
endif()

if (NOT CMAKE_INSTALL_BINDIR)
    set(CMAKE_INSTALL_BINDIR ".")
endif()

if (NOT CMAKE_INSTALL_INCLUDEDIR)
    set(CMAKE_INSTALL_INCLUDEDIR "include")
endif()

set(CMAKE_CXX_STANDARD 14)

foreach (FLAG all "" pedantic extra error=return-type no-unused-parameter no-gnu-zero-variadic-macro-arguments)
    CHECK_CXX_COMPILER_FLAG("-W${FLAG}" WARN_${FLAG}_SUPPORTED)
    if ( WARN_${FLAG}_SUPPORTED AND NOT CMAKE_CXX_FLAGS MATCHES "(^| )-W?${FLAG}($| )")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -W${FLAG}")
    endif ()
endforeach ()

find_package(Qt5 5.9 REQUIRED Network Gui Multimedia Test)
get_filename_component(Qt5_Prefix "${Qt5_DIR}/../../../.." ABSOLUTE)

set(LIBRARY_NAME "Quotient")

find_package(${LIBRARY_NAME} REQUIRED)
get_filename_component(Quotient_Prefix "${Quotient_DIR}/../.." ABSOLUTE)

message( STATUS "${PROJECT_NAME} configuration:" )
if (CMAKE_BUILD_TYPE)
    message( STATUS "  Build type: ${CMAKE_BUILD_TYPE}")
endif(CMAKE_BUILD_TYPE)
message( STATUS "  Compiler: ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}" )
message( STATUS "  Qt: ${Qt5_VERSION} at ${Qt5_Prefix}" )
message( STATUS "  ${LIBRARY_NAME}: ${${LIBRARY_NAME}_VERSION} at ${${LIBRARY_NAME}_Prefix}" )

set(example_SRCS quotest.cpp)

add_executable(${PROJECT_NAME} ${example_SRCS})
target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Test ${LIBRARY_NAME})

# Installation

install (TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== debian/changelog ===
libquotient (0.6.6-1) unstable; urgency=high

  * New upstream release. This fixes a remotely-triggered crash (see
    https://github.com/quotient-im/libQuotient/issues/456).

 -- Andres Salomon <dilinger@debian.org>  Sat, 27 Mar 2021 23:51:17 -0400

libquotient (0.6.4-2) unstable; urgency=medium

  * Remove libqmatrixclient-dev dummy package; Hubert pointed out that
    we may want both dev packages installable, and they don't actually
    conflict.

 -- Andres Salomon <dilinger@debian.org>  Tue, 19 Jan 2021 17:21:30 -0500

libquotient (0.6.4-1) unstable; urgency=medium

  * New upstream release (closes: #980067).
  * Add myself as an uploader.
  * Upstream renamed the library from libqmatrixclient to libQuotient;
    rename the packages accordingly, with a dummy -dev package.

 -- Andres Salomon <dilinger@debian.org>  Mon, 18 Jan 2021 04:16:19 -0500

libqmatrixclient (0.5.3.2-1) unstable; urgency=medium

  * New upstream release.
  * Set packaging team as maintainer.

 -- Hubert Chathi <uhoreg@debian.org>  Fri, 17 Apr 2020 16:32:17 -0400

libqmatrixclient (0.5.2-1) unstable; urgency=medium

  * New upstream release.

 -- Hubert Chathi <uhoreg@debian.org>  Tue, 25 Jun 2019 16:35:11 -0400

libqmatrixclient (0.4.2.1-1) unstable; urgency=medium

  * New upstream release.

 -- Hubert Chathi <uhoreg@debian.org>  Mon, 14 Jan 2019 11:21:36 -0500

libqmatrixclient (0.4.1-1) unstable; urgency=medium

  * Initial release of splitting the library out from quaternion.

 -- Hubert Chathi <uhoreg@debian.org>  Mon, 24 Dec 2018 15:11:03 -0500

=== debian/control ===
Source: libquotient
Priority: optional
Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
Uploaders: Hubert Chathi <uhoreg@debian.org>, Andres Salomon <dilinger@debian.org>
Build-Depends: debhelper-compat (= 12), cmake, qtbase5-dev, qtmultimedia5-dev
Standards-Version: 4.3.0
Section: libs
Homepage: https://github.com/quotient-im/libQuotient
Vcs-Git: https://salsa.debian.org/matrix-team/libquotient.git
Vcs-Browser: https://salsa.debian.org/matrix-team/libquotient

Package: libquotient-dev
Section: libdevel
Architecture: any
Depends: libquotient0.6 (= ${binary:Version}), ${misc:Depends}
Description: Qt5 library to write cross-platform clients for Matrix
 libQuotient is a Qt5-based library to make IM clients for the Matrix
 protocol. It is the backbone of Quaternion, Spectral and some other projects.

Package: libquotient0.6
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Qt5 library to write cross-platform clients for Matrix
 libQuotient is a Qt5-based library to make IM clients for the Matrix
 protocol. It is the backbone of Quaternion, Spectral and some other projects.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_INCLUDEDIR=include/libquotient -DBUILD_SHARED_LIBS=1

override_dh_auto_install:
	dh_auto_install
# unused example file -- remove to avoid warning from dh_missing
	rm debian/tmp/usr/bin/quotest

## libquotient 0.6.11

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 endif()
 
 set(API_VERSION "0.6")
-project(Quotient VERSION "${API_VERSION}.6" LANGUAGES CXX)
+project(Quotient VERSION "${API_VERSION}.11" LANGUAGES CXX)
 
 option(${PROJECT_NAME}_INSTALL_TESTS "install quotest (former qmc-example) application" ON)
 # https://github.com/quotient-im/libQuotient/issues/369
@@ -85,18 +85,28 @@
     message( STATUS "End-to-end encryption (E2EE) support is turned off.")
 endif ()
 
-if (GTAD_PATH)
+if (GTAD_PATH AND MATRIX_DOC_PATH)
     get_filename_component(ABS_GTAD_PATH "${GTAD_PATH}" REALPATH)
-endif ()
-if (MATRIX_DOC_PATH)
-    get_filename_component(ABS_API_DEF_PATH "${MATRIX_DOC_PATH}/api" REALPATH)
-endif ()
-if (ABS_GTAD_PATH AND ABS_API_DEF_PATH)
-    if (NOT CLANG_FORMAT)
-        set(CLANG_FORMAT clang-format)
-    endif()
-    get_filename_component(ABS_CLANG_FORMAT "${CLANG_FORMAT}" PROGRAM)
-endif()
+    if (EXISTS ${ABS_GTAD_PATH})
+        get_filename_component(ABS_API_DEF_PATH "${MATRIX_DOC_PATH}/data/api" REALPATH)
+        message (STATUS "Testing ${ABS_API_DEF_PATH}")
+        if (NOT IS_DIRECTORY ${ABS_API_DEF_PATH})
+            get_filename_component(ABS_API_DEF_PATH "${MATRIX_DOC_PATH}/api" REALPATH)
+            message (STATUS "Testing ${ABS_API_DEF_PATH}")
+        endif ()
+        if (IS_DIRECTORY ${ABS_API_DEF_PATH})
+            set(GENERATE_API 1)
+            if (NOT CLANG_FORMAT)
+                set(CLANG_FORMAT clang-format)
+            endif()
+            get_filename_component(ABS_CLANG_FORMAT "${CLANG_FORMAT}" PROGRAM)
+        else ()
+            message( WARNING "${MATRIX_DOC_PATH} doesn't seem to point to a valid matrix-doc repo; disabling API stubs generation")
+        endif ()
+    else (EXISTS ${ABS_GTAD_PATH})
+        message( WARNING "${GTAD_PATH} doesn't exist; disabling API stubs generation")
+    endif ()
+endif ()
 
 message( STATUS )
 message( STATUS "=============================================================================" )
@@ -110,11 +120,11 @@
 message( STATUS "Install Prefix: ${CMAKE_INSTALL_PREFIX}" )
 message( STATUS "  Header files will be installed to ${CMAKE_INSTALL_PREFIX}/${${PROJECT_NAME}_INSTALL_INCLUDEDIR}" )
 message( STATUS "Using Qt ${Qt5_VERSION} at ${Qt5_Prefix}" )
-if (ABS_API_DEF_PATH AND ABS_GTAD_PATH)
+if (GENERATE_API)
     message( STATUS "Generating API stubs enabled (use --target update-api)" )
     message( STATUS "  Using GTAD at ${ABS_GTAD_PATH}" )
     message( STATUS "  Using API files at ${ABS_API_DEF_PATH}" )
-    if (ABS_CLANG_FORMAT)
+    if (EXISTS ${ABS_CLANG_FORMAT})
         message( STATUS "clang-format is at ${ABS_CLANG_FORMAT}")
     else ()
         message( STATUS "${CLANG_FORMAT} is NOT FOUND; API files won't be reformatted")
@@ -141,6 +151,11 @@
 
 # Set up source files
 set(lib_SRCS
+    # This .h is special in that it declares a Q_NAMESPACE but has no .cpp
+    # where staticMetaObject for that namespace would be defined; passing it
+    # to add_library (see below) puts it on the automoc radar, producing
+    # a compilation unit with the needed definition.
+    lib/quotient_common.h
     lib/networkaccessmanager.cpp
     lib/connectiondata.cpp
     lib/connection.cpp
@@ -190,7 +205,7 @@
 set(ASAPI_DEF_DIR application-service/definitions)
 set(ISAPI_DEF_DIR identity/definitions)
 
-if (MATRIX_DOC_PATH AND GTAD_PATH)
+if (GENERATE_API)
     if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.12.0")
         # We use globbing with CONFIGURE_DEPENDS to produce two file lists:
         # one of all API files for clang-format and another of just .cpp
@@ -222,7 +237,7 @@
         VERBATIM
     )
     add_custom_target(update-api DEPENDS generate-unformatted-api)
-    if (ABS_CLANG_FORMAT)
+    if (EXISTS ${ABS_CLANG_FORMAT})
         set(CLANG_FORMAT_ARGS -i -sort-includes ${CLANG_FORMAT_ARGS})
         # FIXME: the list of files should be produced after GTAD has run.
         # For now it's produced at CMake invocation. If file() hasn't found
@@ -272,27 +287,3 @@
 
 target_include_directories(${PROJECT_NAME} PUBLIC
     $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/lib>
-    $<INSTALL_INTERFACE:${${PROJECT_NAME}_INSTALL_INCLUDEDIR}>
-)
-if (${PROJECT_NAME}_ENABLE_E2EE)
-    target_link_libraries(${PROJECT_NAME} QtOlm)
-    set(FIND_DEPS "find_dependency(QtOlm)") # For QuotientConfig.cmake.in
-endif()
-target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Network Qt5::Gui Qt5::Multimedia)
-
-set(TEST_BINARY quotest)
-add_executable(${TEST_BINARY} ${tests_SRCS})
-target_link_libraries(${TEST_BINARY} Qt5::Core Qt5::Test ${PROJECT_NAME})
-
-configure_file(${PROJECT_NAME}.pc.in ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc @ONLY NEWLINE_STYLE UNIX)
-
-# Installation
-
-install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}Targets
-        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
-        INCLUDES DESTINATION ${${PROJECT_NAME}_INSTALL_INCLUDEDIR}
-)
-install(DIRECTORY lib/ DESTINATION ${${PROJECT_NAME}_INSTALL_INCLUDEDIR}
-        FILES_MATCHING PATTERN "*.h")
-

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.10)
 
 # This CMakeLists file assumes that the library is installed to CMAKE_INSTALL_PREFIX
 # and ignores the in-tree library code. You can use this to start work on your own client.

=== debian/changelog ===
libquotient (0.6.11-1) unstable; urgency=medium

  * New upstream release.

 -- Hubert Chathi <uhoreg@debian.org>  Sat, 16 Oct 2021 12:21:18 -0400

## libquotient 0.7.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
if (POLICY CMP0092)
cmake_policy(SET CMP0092 NEW)
endif()

set(API_VERSION "0.7")
project(Quotient VERSION "${API_VERSION}.2" LANGUAGES CXX)

message(STATUS)
message(STATUS "Configuring ${PROJECT_NAME} ${PROJECT_VERSION} ==>")

include(FeatureSummary)
include(CTest)

# https://github.com/quotient-im/libQuotient/issues/369
option(${PROJECT_NAME}_ENABLE_E2EE "end-to-end encryption (E2EE) support" OFF)
add_feature_info(EnableE2EE ${PROJECT_NAME}_ENABLE_E2EE
                 "end-to-end encryption (WORK IN PROGRESS)")

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build" FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()
include(CheckCXXCompilerFlag)
if (MSVC)
    add_compile_options(/EHsc /W4
        /wd4100 /wd4127 /wd4242 /wd4244 /wd4245 /wd4267 /wd4365 /wd4456 /wd4459
        /wd4464 /wd4505 /wd4514 /wd4571 /wd4619 /wd4623 /wd4625 /wd4626 /wd4706
        /wd4710 /wd4774 /wd4820 /wd4946 /wd5026 /wd5027)
else()
    foreach (FLAG all pedantic extra error=return-type) # Switch these on
        CHECK_CXX_COMPILER_FLAG("-W${FLAG}" W${FLAG}_SUPPORTED)
        if (W${FLAG}_SUPPORTED AND
                NOT CMAKE_CXX_FLAGS MATCHES "W(no-)?${FLAG}($| )")
            add_compile_options(-W${FLAG})
        endif ()
    endforeach ()
    foreach (FLAG unused-parameter gnu-zero-variadic-macro-arguments
                  subobject-linkage) # Switch these off
        CHECK_CXX_COMPILER_FLAG("-Wno-${FLAG}" Wno-${FLAG}_SUPPORTED)
        if (Wno-${FLAG}_SUPPORTED AND
                NOT CMAKE_CXX_FLAGS MATCHES "W(no-)?${FLAG}($| )")
            add_compile_options(-Wno-${FLAG})
        endif()
    endforeach ()
    # disable exceptions by default, not used in most parts here and saves about 10% binary size
    add_compile_options(-fno-exceptions)
endif()

if (WIN32)
    if (NOT CMAKE_INSTALL_LIBDIR)
        set(CMAKE_INSTALL_LIBDIR ".")
        set(CMakeFilesLocation "cmake")
    else()
        set(CMakeFilesLocation "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")
    endif()

    if (NOT CMAKE_INSTALL_BINDIR)
        set(CMAKE_INSTALL_BINDIR ".")
    endif()

    if (NOT CMAKE_INSTALL_INCLUDEDIR)
        set(CMAKE_INSTALL_INCLUDEDIR "include")
    endif()
else()
    include(GNUInstallDirs)
    set(CMakeFilesLocation "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")
endif(WIN32)
set(${PROJECT_NAME}_INSTALL_INCLUDEDIR
        "${CMAKE_INSTALL_INCLUDEDIR}/" CACHE PATH
        "directory to install ${PROJECT_NAME} include files to")

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

option(BUILD_WITH_QT6 "Build Quotient with Qt 6 (EXPERIMENTAL)" OFF)

if (BUILD_WITH_QT6)
    set(QtMinVersion "6.0")
else()
    set(QtMinVersion "5.15")
    set(QtExtraModules "Multimedia") # See #483
endif()
string(REGEX REPLACE "^(.).*" "Qt\\1" Qt ${QtMinVersion}) # makes "Qt5" or "Qt6"
find_package(${Qt} ${QtMinVersion} REQUIRED Core Network Gui Test ${QtExtraModules})
get_filename_component(Qt_Prefix "${${Qt}_DIR}/../../../.." ABSOLUTE)

find_package(${Qt}Keychain REQUIRED)

if (${PROJECT_NAME}_ENABLE_E2EE)
    find_package(${Qt} ${QtMinVersion} REQUIRED Sql)
    find_package(Olm 3.2.5 REQUIRED)
    set_package_properties(Olm PROPERTIES
        DESCRIPTION "Implementation of the Olm and Megolm cryptographic ratchets"
        URL "https://gitlab.matrix.org/matrix-org/olm"
        TYPE REQUIRED
    )

    find_package(OpenSSL 1.1.0 REQUIRED)
    set_package_properties(OpenSSL PROPERTIES
        DESCRIPTION "Open source SSL and TLS implementation and cryptographic library"
        URL "https://www.openssl.org/"
        TYPE REQUIRED
    )
endif()

# Set up source files
list(APPEND lib_SRCS
    Quotient/quotient_common.h
    Quotient/quotient_export.h
    Quotient/function_traits.h Quotient/function_traits.cpp
    Quotient/omittable.h
    Quotient/expected.h
    Quotient/networkaccessmanager.h Quotient/networkaccessmanager.cpp
    Quotient/connectiondata.h Quotient/connectiondata.cpp
    Quotient/connection.h Quotient/connection.cpp
    Quotient/connection_p.h
    Quotient/ssosession.h Quotient/ssosession.cpp
    Quotient/logging.h Quotient/logging.cpp
    Quotient/room.h Quotient/room.cpp
    Quotient/roomstateview.h Quotient/roomstateview.cpp
    Quotient/user.h Quotient/user.cpp
    Quotient/avatar.h Quotient/avatar.cpp
    Quotient/uri.h Quotient/uri.cpp
    Quotient/uriresolver.h Quotient/uriresolver.cpp
    Quotient/eventstats.h Quotient/eventstats.cpp
    Quotient/syncdata.h Quotient/syncdata.cpp
    Quotient/settings.h Quotient/settings.cpp
    Quotient/networksettings.h Quotient/networksettings.cpp
    Quotient/converters.h Quotient/converters.cpp
    Quotient/util.h Quotient/util.cpp
    Quotient/eventitem.h Quotient/eventitem.cpp
    Quotient/accountregistry.h Quotient/accountregistry.cpp
    Quotient/mxcreply.h Quotient/mxcreply.cpp
    Quotient/e2ee/e2ee_common.h # because it's used by generated API
    Quotient/events/event.h Quotient/events/event.cpp
    Quotient/events/eventloader.h
    Quotient/events/roomevent.h Quotient/events/roomevent.cpp
    Quotient/events/stateevent.h Quotient/events/stateevent.cpp
    Quotient/events/single_key_value.h
    Quotient/events/simplestateevents.h
    Quotient/events/eventcontent.h Quotient/events/eventcontent.cpp
    Quotient/events/eventrelation.h Quotient/events/eventrelation.cpp
    Quotient/events/roomcreateevent.h Quotient/events/roomcreateevent.cpp
    Quotient/events/roomtombstoneevent.h Quotient/events/roomtombstoneevent.cpp
    Quotient/events/roommessageevent.h Quotient/events/roommessageevent.cpp
    Quotient/events/roommemberevent.h Quotient/events/roommemberevent.cpp
    Quotient/events/roomcanonicalaliasevent.h
    Quotient/events/roomavatarevent.h
    Quotient/events/roompowerlevelsevent.h Quotient/events/roompowerlevelsevent.cpp
    Quotient/events/typingevent.h
    Quotient/events/accountdataevents.h
    Quotient/events/receiptevent.h Quotient/events/receiptevent.cpp
    Quotient/events/reactionevent.h
    Quotient/events/callevents.h Quotient/events/callevents.cpp
    Quotient/events/directchatevent.h Quotient/events/directchatevent.cpp
    Quotient/events/encryptionevent.h Quotient/events/encryptionevent.cpp
    Quotient/events/encryptedevent.h Quotient/events/encryptedevent.cpp
    Quotient/events/roomkeyevent.h
    Quotient/events/stickerevent.h
    Quotient/events/filesourceinfo.h Quotient/events/filesourceinfo.cpp
    Quotient/jobs/requestdata.h Quotient/jobs/requestdata.cpp
    Quotient/jobs/basejob.h Quotient/jobs/basejob.cpp
    Quotient/jobs/syncjob.h Quotient/jobs/syncjob.cpp
    Quotient/jobs/mediathumbnailjob.h Quotient/jobs/mediathumbnailjob.cpp
    Quotient/jobs/downloadfilejob.h Quotient/jobs/downloadfilejob.cpp
    libquotientemojis.qrc
)
if (${PROJECT_NAME}_ENABLE_E2EE)
    list(APPEND lib_SRCS
        Quotient/database.h Quotient/database.cpp
        Quotient/keyverificationsession.h Quotient/keyverificationsession.cpp
        Quotient/e2ee/e2ee_common.cpp # .h is in the common sources list
        Quotient/e2ee/qolmaccount.h Quotient/e2ee/qolmaccount.cpp
        Quotient/e2ee/qolmsession.h Quotient/e2ee/qolmsession.cpp
        Quotient/e2ee/qolminboundsession.h Quotient/e2ee/qolminboundsession.cpp
        Quotient/e2ee/qolmoutboundsession.h Quotient/e2ee/qolmoutboundsession.cpp
        Quotient/e2ee/qolmutility.h Quotient/e2ee/qolmutility.cpp
        Quotient/e2ee/qolmsession.h Quotient/e2ee/qolmsession.cpp
        Quotient/e2ee/qolmmessage.h Quotient/e2ee/qolmmessage.cpp
        Quotient/events/keyverificationevent.h
    )
endif()

# Configure API files generation

set(CSAPI_DIR csapi)
set(FULL_CSAPI_DIR Quotient/${CSAPI_DIR})
set(ASAPI_DEF_DIR application-service/definitions)
set(ISAPI_DEF_DIR identity/definitions)

set(API_GENERATION_ENABLED 0)
if (NOT MATRIX_SPEC_PATH AND MATRIX_DOC_PATH)
    set(MATRIX_SPEC_PATH ${MATRIX_DOC_PATH})
endif()
if (GTAD_PATH AND MATRIX_SPEC_PATH)
    # REALPATH resolves ~ (home directory) while PROGRAM doesn't
    get_filename_component(ABS_GTAD_PATH "${GTAD_PATH}" REALPATH)
    get_filename_component(ABS_GTAD_PATH "${ABS_GTAD_PATH}" PROGRAM PROGRAM_ARGS GTAD_ARGS)
    if (EXISTS ${ABS_GTAD_PATH})
        get_filename_component(ABS_API_DEF_PATH "${MATRIX_SPEC_PATH}/data/api" REALPATH)
        if (NOT IS_DIRECTORY ${ABS_API_DEF_PATH})
            # Check the old place of API files
            get_filename_component(ABS_API_DEF_PATH "${MATRIX_SPEC_PATH}/api" REALPATH)
        endif ()
        if (IS_DIRECTORY ${ABS_API_DEF_PATH})
            set(API_GENERATION_ENABLED 1)
        else ()
            message( WARNING "${MATRIX_SPEC_PATH} doesn't seem to point to a valid matrix-doc repo; disabling API stubs generation")
        endif ()
    else (EXISTS ${ABS_GTAD_PATH})
        message( WARNING "${GTAD_PATH} is not executable; disabling API stubs generation")
    endif ()
endif ()
if (API_GENERATION_ENABLED)
    message( STATUS "Using GTAD at ${ABS_GTAD_PATH}" )
    message( STATUS "Found API files at ${ABS_API_DEF_PATH}" )
    if (NOT CLANG_FORMAT)
        set(CLANG_FORMAT clang-format)
    endif()
    get_filename_component(ABS_CLANG_FORMAT "${CLANG_FORMAT}" PROGRAM PROGRAM_ARGS CLANG_FORMAT_ARGS)
    if (NOT ABS_CLANG_FORMAT)
        message( WARNING "${CLANG_FORMAT} is NOT FOUND; API files won't be formatted")
    endif ()

    set(FULL_CSAPI_SRC_DIR ${ABS_API_DEF_PATH}/client-server)
    file(GLOB_RECURSE API_DEFS RELATIVE ${PROJECT_SOURCE_DIR}
        ${FULL_CSAPI_SRC_DIR}/*.yaml
        ${ABS_API_DEF_PATH}/${ASAPI_DEF_DIR}/*.yaml
        ${ABS_API_DEF_PATH}/${ISAPI_DEF_DIR}/*.yaml
    )
    add_custom_target(update-api
        ${ABS_GTAD_PATH} --config ../gtad/gtad.yaml --out ${CSAPI_DIR}
            ${FULL_CSAPI_SRC_DIR}
            old_sync.yaml- room_initial_sync.yaml- # deprecated
            key_backup.yaml- # immature and buggy in terms of API definition
            sync.yaml- # we have a better handcrafted implementation
            ${GTAD_ARGS}
        WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/Quotient
        SOURCES gtad/gtad.yaml
                gtad/data.h.mustache
                gtad/operation.h.mustache
                gtad/operation.cpp.mustache
                ${API_DEFS}
        VERBATIM
    )
endif()
add_feature_info(EnableApiCodeGeneration "${API_GENERATION_ENABLED}"
                 "build target update-api")

# Produce the list of all Matrix API files for building the library. When this
# list changes (normally after calling GTAD), CONFIGURE_DEPENDS will force
# the build system to call CMake again. Checking for the glob change slows down
# each build (even if the target does not involve API generation). It would be
# ideal if GTAD could compare the initial (saved somewhere) and the generated
# file list itself and write down to some .cmake file if those are different,
# which would trigger the reconfiguration specifically before the next build.
# For now CONFIGURE_DEPENDS is the best approximation of that.
file(GLOB_RECURSE api_ALL_SRCS CONFIGURE_DEPENDS
     ${FULL_CSAPI_DIR}/*.* Quotient/${ASAPI_DEF_DIR}/*.* Quotient/${ISAPI_DEF_DIR}/*.*)

add_compile_options(
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_URL_CAST_FROM_STRING
    -DQT_NO_CAST_FROM_BYTEARRAY
    -DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT
    -DQT_NO_FOREACH
)

add_library(${PROJECT_NAME} ${lib_SRCS} ${api_ALL_SRCS})
# Set BUILDING_SHARED_QUOTIENT if building as a shared library
target_compile_definitions(${PROJECT_NAME} PRIVATE
    $<$<STREQUAL:$<TARGET_PROPERTY:${PROJECT_NAME},TYPE>,SHARED_LIBRARY>:BUILDING_SHARED_QUOTIENT>)
# Set QUOTIENT_STATIC in a static library setting

=== autotests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Carl Schwan <carlschwan@kde.org>
#
# SPDX-License-Identifier: BSD-3-Clause

include(CMakeParseArguments)

add_custom_target(autotests ALL)

function(QUOTIENT_ADD_TEST)
    cmake_parse_arguments(ARG "" "NAME" "" ${ARGN})
    add_executable(${ARG_NAME} ${ARG_NAME}.cpp)
    target_link_libraries(${ARG_NAME} ${Qt}::Core ${Qt}::Test Quotient)
    add_test(NAME ${ARG_NAME} COMMAND ${ARG_NAME})
    add_dependencies(autotests ${ARG_NAME})
endfunction()

quotient_add_test(NAME callcandidateseventtest)
quotient_add_test(NAME utiltests)
if(${PROJECT_NAME}_ENABLE_E2EE)
    quotient_add_test(NAME testolmaccount)
    quotient_add_test(NAME testgroupsession)
    quotient_add_test(NAME testolmsession)
    if (NOT MSVC)
        target_compile_options(testolmsession PRIVATE -fexceptions)
    endif()
    quotient_add_test(NAME testolmutility)
    quotient_add_test(NAME testfilecrypto)
    quotient_add_test(NAME testkeyverification)
endif()

=== quotest/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Carl Schwan <carlschwan@kde.org>
#
# SPDX-License-Identifier: BSD-3-Clause

set(quotest_SRCS quotest.cpp)

find_package(${Qt} COMPONENTS Concurrent)
add_executable(quotest ${quotest_SRCS})
target_link_libraries(quotest PRIVATE ${Qt}::Core ${Qt}::Test ${Qt}::Concurrent ${PROJECT_NAME})

set_target_properties(quotest PROPERTIES
    VISIBILITY_INLINES_HIDDEN ON
    CXX_VISIBILITY_PRESET hidden
)

if (MSVC)
    target_compile_options(quotest PUBLIC /EHsc /W4
        /wd4100 /wd4127 /wd4242 /wd4244 /wd4245 /wd4267 /wd4365 /wd4456 /wd4459
        /wd4464 /wd4505 /wd4514 /wd4571 /wd4619 /wd4623 /wd4625 /wd4626 /wd4706
        /wd4710 /wd4774 /wd4820 /wd4946 /wd5026 /wd5027)
else()
    foreach (FLAG W Wall Wpedantic Wextra Wno-unused-parameter Werror=return-type)
        CHECK_CXX_COMPILER_FLAG("-${FLAG}" COMPILER_${FLAG}_SUPPORTED)
        if (COMPILER_${FLAG}_SUPPORTED AND
                NOT CMAKE_CXX_FLAGS MATCHES "(^| )-?${FLAG}($| )")
            target_compile_options(quotest PUBLIC -${FLAG})
        endif ()
    endforeach ()
endif()

option(${PROJECT_NAME}_INSTALL_TESTS "install quotest application" ON)
add_feature_info(InstallQuotest ${PROJECT_NAME}_INSTALL_TESTS
                 "the library functional test suite")

if (${PROJECT_NAME}_INSTALL_TESTS)
    install(TARGETS quotest RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif ()

=== debian/changelog ===
libquotient (0.7.2-0ubuntu5) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 07:57:17 +0000

libquotient (0.7.2-0ubuntu4) noble; urgency=medium

  * Fix FTBFS with nocheck profile.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 27 Mar 2024 14:37:23 +0100

libquotient (0.7.2-0ubuntu3) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 05:41:52 +0000

libquotient (0.7.2-0ubuntu2) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 18:26:58 +0000

libquotient (0.7.2-0ubuntu1) mantic; urgency=medium

  * New upstream release (0.7.2)

 -- Rik Mills <rikmills@kde.org>  Tue, 08 Aug 2023 23:31:00 +0100

libquotient (0.7.1-2) experimental; urgency=medium

  * debian/control: add dependency on libolm-dev libssl-dev for dev package
  * debian/rules: don't let test write in home directory

 -- Hubert Chathi <uhoreg@debian.org>  Wed, 11 Jan 2023 18:10:43 -0500

libquotient (0.7.1-1) experimental; urgency=medium

  * New upstream release.
  * Enable end-to-end encryption support.

 -- Hubert Chathi <uhoreg@debian.org>  Mon, 09 Jan 2023 17:31:27 -0500

=== debian/control ===
Source: libquotient
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
Uploaders: Hubert Chathi <uhoreg@debian.org>, Andres Salomon <dilinger@debian.org>
Build-Depends:
  debhelper-compat (= 12),
  cmake,
  libolm-dev,
  libssl-dev,
  qtbase5-dev,
  qtmultimedia5-dev,
  qt5keychain-dev
Standards-Version: 4.3.0
Section: libs
Homepage: https://github.com/quotient-im/libQuotient
Vcs-Git: https://salsa.debian.org/matrix-team/libquotient.git
Vcs-Browser: https://salsa.debian.org/matrix-team/libquotient

Package: libquotient-dev
Section: libdevel
Architecture: any
Depends: libquotient0.7 (= ${binary:Version}), ${misc:Depends}
Description: Qt5 library to write cross-platform clients for Matrix
 libQuotient is a Qt5-based library to make IM clients for the Matrix
 protocol. It is the backbone of Quaternion, Spectral and some other projects.

Package: libquotient0.7
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libolm-dev, libssl-dev
Description: Qt5 library to write cross-platform clients for Matrix
 libQuotient is a Qt5-based library to make IM clients for the Matrix
 protocol. It is the backbone of Quaternion, Spectral and some other projects.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_INCLUDEDIR=include/libquotient -DBUILD_SHARED_LIBS=1 -DQuotient_ENABLE_E2EE=1

override_dh_auto_install:
	dh_auto_install
# unused example file -- remove to avoid warning from dh_missing
	rm -f debian/tmp/usr/bin/quotest

override_dh_auto_test:
# testolmaccount needs a local synapse running, so skip it
# testverification writes to home directory, so make a dummy home directory for it
	mkdir debian/dummyhome
	HOME=$(CURDIR)/debian/dummyhome dh_auto_test -- ARGS\+=-E ARGS\+=testolmaccount
	rm -rf debian/dummyhome

## libquotient 0.8.1.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,8 +3,8 @@
 cmake_policy(SET CMP0092 NEW)
 endif()
 
-set(API_VERSION "0.7")
-project(Quotient VERSION "${API_VERSION}.2" LANGUAGES CXX)
+set(API_VERSION "0.8")
+project(Quotient VERSION "${API_VERSION}.1.2" LANGUAGES CXX)
 
 message(STATUS)
 message(STATUS "Configuring ${PROJECT_NAME} ${PROJECT_VERSION} ==>")
@@ -51,12 +51,31 @@
     add_compile_options(-fno-exceptions)
 endif()
 
+add_compile_definitions(
+    QT_NO_JAVA_STYLE_ITERATORS QT_NO_URL_CAST_FROM_STRING QT_NO_CAST_TO_ASCII
+    QT_NO_CAST_FROM_ASCII QT_STRICT_ITERATORS QT_NO_CAST_FROM_BYTEARRAY
+    QT_NO_NARROWING_CONVERSIONS_IN_CONNECT QT_NO_FOREACH)
+
+set_directory_properties(PROPERTIES
+    CXX_STANDARD 20
+    CXX_EXTENSIONS OFF
+    VISIBILITY_INLINES_HIDDEN ON
+    CXX_VISIBILITY_PRESET hidden
+)
+
+option(BUILD_WITH_QT6 "Build Quotient with Qt 6 (EXPERIMENTAL)" OFF)
+if (BUILD_WITH_QT6)
+    set(QUOTIENT_LIB_NAME ${PROJECT_NAME}Qt6)
+else()
+    set(QUOTIENT_LIB_NAME ${PROJECT_NAME})
+endif()
+
 if (WIN32)
     if (NOT CMAKE_INSTALL_LIBDIR)
         set(CMAKE_INSTALL_LIBDIR ".")
         set(CMakeFilesLocation "cmake")
     else()
-        set(CMakeFilesLocation "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")
+        set(CMakeFilesLocation "${CMAKE_INSTALL_LIBDIR}/cmake/${QUOTIENT_LIB_NAME}")
     endif()
 
     if (NOT CMAKE_INSTALL_BINDIR)
@@ -68,7 +87,7 @@
     endif()
 else()
     include(GNUInstallDirs)
-    set(CMakeFilesLocation "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")
+    set(CMakeFilesLocation "${CMAKE_INSTALL_LIBDIR}/cmake/${QUOTIENT_LIB_NAME}")
 endif(WIN32)
 set(${PROJECT_NAME}_INSTALL_INCLUDEDIR
         "${CMAKE_INSTALL_INCLUDEDIR}/" CACHE PATH
@@ -77,8 +96,6 @@
 # Instruct CMake to run moc automatically when needed.
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
-
-option(BUILD_WITH_QT6 "Build Quotient with Qt 6 (EXPERIMENTAL)" OFF)
 
 if (BUILD_WITH_QT6)
     set(QtMinVersion "6.0")
@@ -121,7 +138,7 @@
     Quotient/connection.h Quotient/connection.cpp
     Quotient/connection_p.h
     Quotient/ssosession.h Quotient/ssosession.cpp
-    Quotient/logging.h Quotient/logging.cpp
+    Quotient/logging_categories_p.h
     Quotient/room.h Quotient/room.cpp
     Quotient/roomstateview.h Quotient/roomstateview.cpp
     Quotient/user.h Quotient/user.cpp
@@ -174,6 +191,7 @@
 if (${PROJECT_NAME}_ENABLE_E2EE)
     list(APPEND lib_SRCS
         Quotient/database.h Quotient/database.cpp
+        Quotient/connectionencryptiondata_p.h Quotient/connectionencryptiondata_p.cpp
         Quotient/keyverificationsession.h Quotient/keyverificationsession.cpp
         Quotient/e2ee/e2ee_common.cpp # .h is in the common sources list
         Quotient/e2ee/qolmaccount.h Quotient/e2ee/qolmaccount.cpp
@@ -238,7 +256,6 @@
         ${ABS_GTAD_PATH} --config ../gtad/gtad.yaml --out ${CSAPI_DIR}
             ${FULL_CSAPI_SRC_DIR}
             old_sync.yaml- room_initial_sync.yaml- # deprecated
-            key_backup.yaml- # immature and buggy in terms of API definition
             sync.yaml- # we have a better handcrafted implementation
             ${GTAD_ARGS}
         WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/Quotient
@@ -264,17 +281,3 @@
 file(GLOB_RECURSE api_ALL_SRCS CONFIGURE_DEPENDS
      ${FULL_CSAPI_DIR}/*.* Quotient/${ASAPI_DEF_DIR}/*.* Quotient/${ISAPI_DEF_DIR}/*.*)
 
-add_compile_options(
-    -DQT_NO_CAST_TO_ASCII
-    -DQT_NO_CAST_FROM_ASCII
-    -DQT_NO_URL_CAST_FROM_STRING
-    -DQT_NO_CAST_FROM_BYTEARRAY
-    -DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT
-    -DQT_NO_FOREACH
-)
-
-add_library(${PROJECT_NAME} ${lib_SRCS} ${api_ALL_SRCS})
-# Set BUILDING_SHARED_QUOTIENT if building as a shared library
-target_compile_definitions(${PROJECT_NAME} PRIVATE
-    $<$<STREQUAL:$<TARGET_PROPERTY:${PROJECT_NAME},TYPE>,SHARED_LIBRARY>:BUILDING_SHARED_QUOTIENT>)
-# Set QUOTIENT_STATIC in a static library setting

=== autotests/CMakeLists.txt ===
--- 
+++ 
@@ -8,8 +8,8 @@
 
 function(QUOTIENT_ADD_TEST)
     cmake_parse_arguments(ARG "" "NAME" "" ${ARGN})
-    add_executable(${ARG_NAME} ${ARG_NAME}.cpp)
-    target_link_libraries(${ARG_NAME} ${Qt}::Core ${Qt}::Test Quotient)
+    add_executable(${ARG_NAME} ${ARG_NAME}.cpp testutils.cpp)
+    target_link_libraries(${ARG_NAME} ${Qt}::Core ${Qt}::Test ${QUOTIENT_LIB_NAME})
     add_test(NAME ${ARG_NAME} COMMAND ${ARG_NAME})
     add_dependencies(autotests ${ARG_NAME})
 endfunction()

=== debian/changelog ===
libquotient (0.8.1.2-2) unstable; urgency=medium

  * Upload to unstable.

 -- Hubert Chathi <uhoreg@debian.org>  Mon, 13 May 2024 21:59:33 -0400

libquotient (0.8.1.2-1) experimental; urgency=medium

  * New upstream release.

 -- Hubert Chathi <uhoreg@debian.org>  Tue, 19 Mar 2024 17:16:07 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: libquotient
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
+Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
 Uploaders: Hubert Chathi <uhoreg@debian.org>, Andres Salomon <dilinger@debian.org>
 Build-Depends:
   debhelper-compat (= 12),
@@ -20,12 +19,12 @@
 Package: libquotient-dev
 Section: libdevel
 Architecture: any
-Depends: libquotient0.7 (= ${binary:Version}), ${misc:Depends}
+Depends: libquotient0.8 (= ${binary:Version}), ${misc:Depends}
 Description: Qt5 library to write cross-platform clients for Matrix
  libQuotient is a Qt5-based library to make IM clients for the Matrix
  protocol. It is the backbone of Quaternion, Spectral and some other projects.
 
-Package: libquotient0.7
+Package: libquotient0.8
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, libolm-dev, libssl-dev
 Description: Qt5 library to write cross-platform clients for Matrix
